﻿Imports System.Globalization

Public Class DurationCalculator

    Public Sub CalculateDuration()
        Dim departure As TimeSpan
        Dim arrival As TimeSpan
        Dim format As String = "g"  'hour:minute value
        Dim timeValid As Boolean = True
        Do
            Console.Write("Departure time (hh:mm):")
            Dim intervalString As String = Console.ReadLine()
            timeValid = TimeSpan.TryParseExact(intervalString,
                    format, CultureInfo.CurrentCulture,
                    TimeSpanStyles.None, departure)
            If (Not timeValid) Then
                Console.WriteLine("Invalid time. Please enter your " &
                        "departure time in hh:mm format " &
                        "(Ex: 10:30 or 21:12)")
            End If
        Loop While (Not timeValid)

        Do
            Console.Write("Arrival time (hh:mm):")
            Dim intervalString As String = Console.ReadLine()
            timeValid = TimeSpan.TryParseExact(intervalString,
                format, CultureInfo.CurrentCulture,
                TimeSpanStyles.None, arrival)
            If (Not timeValid) Then
                Console.WriteLine("Invalid time. Please enter your " &
                        "arrival time in hh:mm format (Ex: 10:30 or 21:12)")
            End If
        Loop While (Not timeValid)

        If (arrival.CompareTo(departure) > 0) Then
            Dim duration As TimeSpan = arrival.Subtract(departure)
            Console.WriteLine("Your flight will take {0} hour(s) " &
                    "and {1} minute(s)", duration.Hours, duration.Minutes)
        Else
            Console.WriteLine("You have entered an arrival time that " &
                    "is earlier than the departure time." &
                    vbCrLf & "Please try again later. ")
        End If
    End Sub

End Class